import { type Request } from '@adonisjs/core/http';
import { type ApplicationService } from '@adonisjs/core/types';
import { type LucidModel } from '@adonisjs/lucid/types/model';
import { type ExtractModelRelations } from '@adonisjs/lucid/types/relations';
import { type Collection } from 'collect.js';
import { type AllowedFilter } from '../src/allowed_filter.js';
import { type AllowedInclude } from '../src/allowed_include.js';
import { type AllowedSort } from '../src/allowed_sort.js';
import { type ApiQueryBuilderRequest } from '../src/api_query_builder_request.js';
import { type ExtractKeys, type HintedString, type SortUnionKeyParams } from '../src/types.js';
export default class ApiQueryProvider {
    protected app: ApplicationService;
    constructor(app: ApplicationService);
    boot(): Promise<void>;
}
declare module '@adonisjs/lucid/orm' {
    interface ModelQueryBuilder {
        withRequest(request: Request): this;
        $apiQueryBuilderRequest: ApiQueryBuilderRequest;
        allowedSorts(...sorts: (AllowedSort<LucidModel> | string)[]): this;
        allowedSorts(sorts: (AllowedSort<LucidModel> | string)[]): this;
        defaultSort(...sorts: (AllowedSort<LucidModel> | string)[]): this;
        defaultSort(sorts: (AllowedSort<LucidModel> | string)[]): this;
        allowedFilters(...filters: (AllowedFilter<LucidModel> | string)[]): this;
        allowedFilters(filters: (AllowedFilter<LucidModel> | string)[]): this;
        allowedIncludes(...includes: (Collection<AllowedInclude<LucidModel>> | string)[]): this;
        allowedIncludes(includes: (Collection<AllowedInclude<LucidModel>> | string)[]): this;
    }
}
declare module '@adonisjs/lucid/types/model' {
    interface ModelQueryBuilderContract<Model extends LucidModel, Result = InstanceType<Model>> {
        withRequest(request: Request): this;
        allowedSorts(...sorts: (AllowedSort<Model> | HintedString<SortUnionKeyParams<Model>>)[]): this;
        allowedSorts(sorts: (AllowedSort<Model> | HintedString<SortUnionKeyParams<Model>>)[]): this;
        defaultSort(...sorts: (AllowedSort<Model> | HintedString<SortUnionKeyParams<Model>>)[]): this;
        defaultSort(sorts: (AllowedSort<Model> | HintedString<SortUnionKeyParams<Model>>)[]): this;
        allowedFilters(...filters: (AllowedFilter<Model> | HintedString<ExtractKeys<ModelAttributes<InstanceType<Model>>>>)[]): this;
        allowedFilters(filters: (AllowedFilter<Model> | HintedString<ExtractKeys<ModelAttributes<InstanceType<Model>>>>)[]): this;
        allowedIncludes(...includes: (Collection<AllowedInclude<Model>> | HintedString<ExtractModelRelations<InstanceType<Model>>>)[]): this;
        allowedIncludes(includes: (Collection<AllowedInclude<Model>> | HintedString<ExtractModelRelations<InstanceType<Model>>>)[]): this;
    }
}
