import { type LucidModel, type ModelAttributes, type ModelQueryBuilderContract } from '@adonisjs/lucid/types/model';
import { type StrictValuesWithoutRaw } from '@adonisjs/lucid/types/querybuilder';
import { Collection } from 'collect.js';
import { type FilterOperator } from './enums/filter_operator.js';
import { type ExtractKeys, type Filter } from './types.js';
export declare class AllowedFilter<Model extends LucidModel> {
    static setFilterArrayValueDelimiter(delimiter?: string): void;
    static exact<Model extends LucidModel>(name: string, internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>, addRelationConstraint?: boolean, arrayValueDelimiter?: string): AllowedFilter<Model>;
    static partial<Model extends LucidModel>(name: string, internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>, addRelationConstraint?: boolean, arrayValueDelimiter?: string): AllowedFilter<Model>;
    static beginsWithStrict<Model extends LucidModel>(name: string, internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>, addRelationConstraint?: boolean, arrayValueDelimiter?: string): AllowedFilter<Model>;
    static endsWithStrict<Model extends LucidModel>(name: string, internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>, addRelationConstraint?: boolean, arrayValueDelimiter?: string): AllowedFilter<Model>;
    static callback<Model extends LucidModel>(name: string, callback: (query: ModelQueryBuilderContract<Model>, value: unknown, property: string) => void, internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>, arrayValueDelimiter?: string): AllowedFilter<Model>;
    static trashed<Model extends LucidModel>(name?: string, internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>): AllowedFilter<Model>;
    static custom<Model extends LucidModel>(name: string, filterClass: Filter<Model>, internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>, arrayValueDelimiter?: string): AllowedFilter<Model>;
    static operator<Model extends LucidModel>(name: string, filterOperator: FilterOperator, boolean?: 'and' | 'or', internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>, addRelationConstraint?: boolean, arrayValueDelimiter?: string): AllowedFilter<Model>;
    protected name: string;
    protected filterClass: Filter<Model>;
    protected internalName: string;
    protected ignored: Collection<unknown>;
    protected default: unknown;
    protected $hasDefault: boolean;
    protected nullable: boolean;
    constructor(name: string, filterClass: Filter<Model>, internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>);
    filter(query: ModelQueryBuilderContract<Model>, value: unknown): void;
    getFilterClass(): Filter<Model>;
    getName(): string;
    isForFilter(filterName: string): boolean;
    ignore(...values: unknown[]): this;
    getIgnored(): unknown[];
    getInternalName(): string;
    setDefault(defaultValue: unknown): this;
    getDefault(): unknown;
    hasDefault(): boolean;
    setNullable(nullable?: boolean): this;
    unsetDefault(): this;
    protected resolveValueForFiltering(value: unknown): StrictValuesWithoutRaw | null;
}
