import { type LucidModel, type ModelQueryBuilderContract } from '@adonisjs/lucid/types/model';
import { type ModelRelations } from '@adonisjs/lucid/types/relations';
import { Collection } from 'collect.js';
import { type Include } from './types.js';
export declare class AllowedInclude<Model extends LucidModel> {
    static relationship<ParentModel extends LucidModel>(name: string, internalName?: string): Collection<AllowedInclude<ParentModel>>;
    static count<ParentModel extends LucidModel>(name: string, internalName?: string): Collection<AllowedInclude<ParentModel>>;
    static callback<ParentModel extends LucidModel, RelatedModel extends LucidModel>(name: string, callback: (query: ModelRelations<RelatedModel, ParentModel>['builder'] | ModelRelations<RelatedModel, ParentModel>['subQuery']) => void, internalName?: string): Collection<AllowedInclude<ParentModel>>;
    static custom<ParentModel extends LucidModel>(name: string, includeClass: Include<ParentModel>, internalName?: string): Collection<AllowedInclude<ParentModel>>;
    protected internalName: string;
    protected name: string;
    protected includeClass: Include<Model>;
    constructor(name: string, includeClass: Include<Model>, internalName?: string);
    include(query: ModelQueryBuilderContract<Model>): void;
    getName(): string;
    isForInclude(includeName: string): boolean;
}
