import { type LucidModel, type ModelAttributes, type ModelQueryBuilderContract } from '@adonisjs/lucid/types/model';
import { type ExtractKeys, type Sort } from './types.js';
export declare class AllowedSort<Model extends LucidModel> {
    static parseSortDirection(name: string): string;
    static field<Model extends LucidModel>(name: string, internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>): AllowedSort<Model>;
    static custom<Model extends LucidModel>(name: string, sortClass: Sort<Model>, internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>): AllowedSort<Model>;
    static callback<Model extends LucidModel>(name: string, callback: (query: ModelQueryBuilderContract<Model>, descending: boolean, property: string) => void, internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>): AllowedSort<Model>;
    protected defaultDirection: string;
    protected internalName: string;
    protected name: string;
    protected sortClass: Sort<Model>;
    constructor(name: string, sortClass: Sort<Model>, internalName?: ExtractKeys<ModelAttributes<InstanceType<Model>>>);
    sort(query: ModelQueryBuilderContract<Model>, descending?: boolean): void;
    getName(): string;
    isSort(sortName: string): boolean;
    getInternalName(): string;
    setDefaultDirection(defaultDirection: string): this;
}
