import { type Request } from '@adonisjs/core/http';
import { Collection } from 'collect.js';
export declare class ApiQueryBuilderRequest {
    protected static includesArrayValueDelimiter: string;
    protected static appendsArrayValueDelimiter: string;
    protected static fieldsArrayValueDelimiter: string;
    protected static sortsArrayValueDelimiter: string;
    protected static filterArrayValueDelimiter: string;
    static setArrayValueDelimiter(delimiter: string): void;
    static setIncludesArrayValueDelimiter(includesArrayValueDelimiter: string): void;
    static setAppendsArrayValueDelimiter(appendsArrayValueDelimiter: string): void;
    static setFieldsArrayValueDelimiter(fieldsArrayValueDelimiter: string): void;
    static setSortsArrayValueDelimiter(sortsArrayValueDelimiter: string): void;
    static setFilterArrayValueDelimiter(filterArrayValueDelimiter: string): void;
    static getIncludesArrayValueDelimiter(): string;
    static getAppendsArrayValueDelimiter(): string;
    static getFieldsArrayValueDelimiter(): string;
    static getSortsArrayValueDelimiter(): string;
    static getFilterArrayValueDelimiter(): string;
    static resetDelimiters(): void;
    static fromRequest(request: Request): ApiQueryBuilderRequest;
    private readonly _request;
    constructor(request?: Request);
    includes(): Collection<string>;
    appends(): Collection<unknown>;
    fields(): Collection<unknown>;
    sorts(): Collection<string>;
    filters(): Collection<unknown>;
    protected getFilterValue(value: unknown): unknown;
    protected getRequestData<T = unknown>(key: string, defaultValue?: T): T;
}
