import { type LucidModel, type ModelQueryBuilderContract } from '@adonisjs/lucid/types/model';
import { type StrictValuesWithoutRaw } from '@adonisjs/lucid/types/querybuilder';
import { FilterOperator } from '../enums/filter_operator.js';
import { type Filter } from '../types.js';
import { FiltersExact } from './filters_exact.js';
export declare class FiltersOperator<Model extends LucidModel> extends FiltersExact<Model> implements Filter<Model> {
    protected $addRelationConstraint: boolean;
    protected $filterOperator: FilterOperator;
    protected $boolean: 'and' | 'or';
    constructor($addRelationConstraint: boolean, $filterOperator: FilterOperator, $boolean: 'and' | 'or');
    handle(query: ModelQueryBuilderContract<Model, InstanceType<Model>>, value: StrictValuesWithoutRaw, property: string): void;
    protected getDynamicFilterOperator(value: string): FilterOperator;
    protected removeDynamicFilterOperatorFromValue(value: string, filterOperator: FilterOperator): string;
}
